// Text.h : Declaration of the Text

#ifndef __TEXT_H_
#define __TEXT_H_

#include "resource.h"       // main symbols
#include <atlmisc.h>
#include "ZeichenObjekt.h"

#include <comdef.h>

/////////////////////////////////////////////////////////////////////////////
// Text
class ATL_NO_VTABLE Text : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<Text, &CLSID_Text>,
	public IDispatchImpl<IText, &IID_IText, &LIBID_TSUZEICHNENLib>,
	public ZeichenObjekt
{
	public:
		Text();

        void draw(CDC& dc);

	DECLARE_REGISTRY_RESOURCEID(IDR_TEXT)

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	BEGIN_COM_MAP(Text)
		COM_INTERFACE_ENTRY(IText)
		COM_INTERFACE_ENTRY(IDispatch)
	END_COM_MAP()

	// IText
	public:
		STDMETHOD(get_Inhalt)(/*[out, retval]*/ BSTR *pVal);
		STDMETHOD(put_Inhalt)(/*[in]*/ BSTR newVal);
		STDMETHOD(get_Y)(/*[out, retval]*/ long *pVal);
		STDMETHOD(put_Y)(/*[in]*/ long newVal);
		STDMETHOD(get_X)(/*[out, retval]*/ long *pVal);
		STDMETHOD(put_X)(/*[in]*/ long newVal);
		STDMETHOD(get_Farbe)(/*[out, retval]*/ OLE_COLOR *pVal);
		STDMETHOD(put_Farbe)(/*[in]*/ OLE_COLOR newVal);

    private:
        CPoint      _point;
        OLE_COLOR   _color;
		_bstr_t		_inhalt;

};

#endif //__TEXT_H_
